########## 
# Mysqlseen v1.0 by Sato1@undernet (rauleli@wizardteam.com)
# 
# For eggdrop1.6.x, tcl8.x, Mytcl and MySQL 3.23.x
# v1.0 (27/11/00) -- First release
# v1.1 (29/11/00) -- dcc commands added
#                    multilanguaje support
#                    speed improvement
# 
# Description: Logs every join/part/sign/kick/ban/split/splitrejoin
#               change of topic/change of nick into a mysql dbase.
#              Displays the last time a nick was seen and how left a
#               channel.
#              Also logs the duration that nick had in a channel
#
# Installation: + copy the sqlseen.tcl into your script 
#                directory.
#               + create a mysql user with enough 
#                privileges to search and add rows.
#               + create the dbase and tables
#                as crea.sql says, you may change the 
#                name of the database, but tables needs
#                to be as shown.
#               + add the line "source scripts/sqlseen.tcl"
#                into your bot config 
#
# Require: MySQL server (www.mysql.com)
#          Mytcl package (www.mytcl.cx)
#
# Usage: /msg <yourbot> seen <nick>
#        seen <nick>
#        !seen <nick>
#        (last 2 channel commands depends on .chanset +seen)
#
# Complementary script: sqllast (read the header)
#
# ToDo: + usage of wildcards
#       + backup option
#
# (Globi: thanks a lot for your help! =)
#
# Note: newer versions and other mysql scripts for eggdrops
#       at ftp://eggdrop.wizardteam.com/pub/eggdrop/mysql-scripts
#       or http://eggdrop.wizardteam.com
########## 

### set the username you have in your mysql server
set sqluser ""

### set the password you have in your mysql server
set sqlpass ""

### set the host where you have your mysql account
set sqlhost ""

### set the database name where your tables are contained
set sqldbase "bots"

### Languaje selector: 1-spanish, 2-english
set sqllang 1

######  Thats it! now enjoy! =)

#######################################################
#####   DO NOT CHANGE ANYTHING AFTER THIS LINE    #####
##### (unless you really know what you are doing) #####
#######################################################
package require mytcl

proc ob {tc dato} {
 global sqluser sqlpass sqlhost sqldbase
 set connuno [sql connect $sqlhost $sqluser $sqlpass]
 sql selectdb $connuno $sqldbase
 set co [sql query $connuno "select id from $tc where $tc = '$dato'"]
 set tt 0
 while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
 sql endquery $connuno $co
 if {$tt == 0} {
  sql exec $connuno "insert into $tc ($tc) values('$dato')" 
  set co [sql query $connuno "select id from $tc where $tc = '$dato'"]
  while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
  sql endquery $connuno $co
 }
 sql disconnect $connuno
 return $tt
}

proc obn {tc dato} {
 global sqluser sqlpass sqlhost sqldbase
 set connuno [sql connect $sqlhost $sqluser $sqlpass]
 sql selectdb $connuno $sqldbase
 set co [sql query $connuno "select $tc from $tc where id = '$dato'"]
 set tt 0
 while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
 sql endquery $connuno $co
 sql disconnect $connuno
 return $tt
}

proc og {cmd} {
 global sqluser sqlpass sqlhost sqldbase
 set connuno [sql connect $sqlhost $sqluser $sqlpass]
 sql selectdb $connuno $sqldbase
 sql exec $connuno "insert into master $cmd" 
 sql disconnect $connuno
}

proc ho {st n} {
 return [lindex [split $st @] $n]
}

proc fec {secs} {
global sqllangref
#.tcl proc myduration {sec} {set sec [duration $sec] ;foreach a {years year weeks week
#days day hours hour minutes minute
# seconds second} b {yrs yr wks wk d d hrs hr mn mn s s} {regsub -all -- $a $sec $b sec}
#;return $sec}

 set regresa ""
 if {$secs > 86400} {
  set dd [expr $secs / 86400]
  set secs [expr $secs - $dd * 86400]
  if {$dd > 1} { set regresa "$dd $sqllangref(dias)" } else {set regresa "$dd $sqllangref(dia)"}
  if {$secs > 0} {set regresa "$regresa, "} else {set regresa "$regresa."}
 }
 if {$secs > 3600} {
  set dd [expr $secs / 3600]
  set secs [expr $secs - $dd * 3600]
  if {$dd > 1} { set regresa "$regresa$dd $sqllangref(horas)" } else {set regresa "$regresa$dd $sqllangref(hora)"}
  if {$secs > 0} {set regresa "$regresa, "} else {set regresa "$regresa."}
 }
 if {$secs > 60} {
  set dd [expr $secs / 60]
  set secs [expr $secs - $dd * 60]
  if {$dd > 1} { set regresa "$regresa$dd $sqllangref(mins)" } else {set regresa "$regresa$dd $sqllangref(min)"}
  if {$secs > 0} {set regresa "$regresa, "} else {set regresa "$regresa."}
 }
 if {$secs > 0} {
  if {$secs > 1} { set regresa "$regresa$secs $sqllangref(secs)" } else {set regresa "$regresa$secs $sqllangref(sec)"}
 }
 return $regresa
}

proc limpia { data } {
  regsub -all -- \\\\ $data \\\\\\\\ data ; regsub -all -- \\\[ $data \\\\\[ data ; regsub -all -- \\\] $data \\\\\] data
  regsub -all -- \\\} $data \\\\\} data ; regsub -all -- \\\{ $data \\\\\{ data ; regsub -all -- \\\" $data \\\\\" data
  regsub -all -- \\\; $data \\\\\; data ; regsub -all -- \\\$ $data \\\\\$ data
  regsub -all -- \' $data \\\' data; regsub -all -- \\\< $data \\\\\< data; regsub -all -- \\\> $data \\\\\> data
  return $data
}

proc las {cmd} {
 global sqluser sqlpass sqlhost sqldbase
 set connuno [sql connect $sqlhost $sqluser $sqlpass]
 sql selectdb $connuno $sqldbase
 set cmd [split $cmd ,]
 if {[string match "*[lindex $cmd 0]*" "15"]} { 
  set co [sql query $connuno "select id from master where stat=[lindex $cmd 0] and nick=[lindex $cmd 1] and ident=[lindex $cmd 2] and host=[lindex $cmd 3] and hand=[lindex $cmd 4]\
                                                  and chan=[lindex $cmd 5] and bot=[lindex $cmd 6] order by fecha_hora desc limit 1"]
  set tt 0
  while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
  sql endquery $connuno $co
  sql exec $connuno "insert into last (lin,nick) values ($tt,[lindex $cmd 1])"
 }
 if {[string match "*[lindex $cmd 0]*" "23467"]} { 
  set nick "and ident=[lindex $cmd 2] and host=[lindex $cmd 3] and hand=[lindex $cmd 4]"
  set nick_a "((mod = [lindex $cmd 1] and stat = 7) or (stat in (1,5) and nick=[lindex $cmd 1])) $nick"
  set nick "stat in (2,3,4,6,7) $nick"
  set n 1

  if {[lindex $cmd 0] == 6} {
   set nick "stat = 6 and mod = [lindex $cmd 7]"
   set nick_a "((mod = [lindex $cmd 7] and stat = 7) or (stat in (1,5) and nick=[lindex $cmd 7]))"
  }

  if {[lindex $cmd 0] == 7} { set n 2 }

  set tt 0
#busca la entrada
  set co [sql query $connuno "select id from master where $nick_a and chan=[lindex $cmd 5] and bot=[lindex $cmd 6] order by fecha_hora desc limit $n"]
  while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
  sql endquery $connuno $co

#busca la salida
  set ta 0
  set co [sql query $connuno "select id from master where $nick and chan=[lindex $cmd 5] and bot=[lindex $cmd 6] order by fecha_hora desc limit 1"]
  while {[set row [sql fetchrow $connuno $co]] != ""} {set ta $row }
  sql endquery $connuno $co
  if {[lindex $cmd 0] == 6} {
   sql exec $connuno "update last set lout=$ta, nick=[lindex $cmd 7] where lin = $tt"
  } else {
   sql exec $connuno "update last set lout=$ta, nick=[lindex $cmd 1] where lin = $tt"
  }
  if {[lindex $cmd 0] == 7} {
   sql exec $connuno "insert into last (lin,nick) values ($ta,[lindex $cmd 7])"
  }
 }
 sql disconnect $connuno
}



bind join -|- * sjoin
bind part -|- * spart
bind sign -|- * ssign
bind splt -|- * ssplit
bind rejn -|- * srejoin
bind nick -|- * snick
bind kick -|- * skick
bind topc -|- * stopic
bind mode -|- * mode_proc_fix
bind msg -|- !seen t_sql_seen 
bind msg -|- seen t_sql_seen
bind pub -|- !seen t_sql_seen_chan
bind dcc -|- seen t_sql_seen_dcc
bind dcc -|- !seen t_sql_seen_dcc
proc t_sql_seen {nick uhost hand arg} {sql_seen $nick $uhost $hand "" 1 0 $arg}
proc t_sql_seen_dcc {hand idx arg} {sql_seen "" "" $hand "" 2 $idx $arg}
proc t_sql_seen_chan {nick uhost hand chan arg} {sql_seen $nick $uhost $hand $chan 0 0 $arg}


proc sql_seen {nick uhost hand chan n idx arg} {
 global sqluser sqlpass sqlhost sqldbase sqllangref
 set targ ""
 switch $n {
  0 {
     if {[lsearch [channel info $chan] "-seen"] > 0} { return }
     set targ "PRIVMSG $chan :$nick -"
    }
  1 {
     set targ "NOTICE $nick :"
     putserv "NOTICE $nick :$sqllangref(intro)" 
    }
 }
 putlog "SEEN $nick |$hand| $arg"
 if {[string tolower $nick] == [string tolower $arg]} {
  putserv "$targ $sqllangref(mismo)"
  return
 }
 foreach canal [channels] {
  if {[onchan $arg $canal]} {
   putserv "$targ \002$arg\002 sqllangref(aqui)!! ($canal)"
   switch $n {
    0 {putserv $targ}
    1 {putlog $targ}
    2 {putdcc $idx $targ}
   }
   return
  }
 }
 set connuno [sql connect $sqlhost $sqluser $sqlpass]
 sql selectdb $connuno $sqldbase
 set co [sql query $connuno "select id from nick where nick = '$arg'"]
 set ni ""
 while {[set row [sql fetchrow $connuno $co]] != ""} {set ni $row }
 sql endquery $connuno $co
 set tt 0
 if {[string length $ni] != 0} {
  set da "unix_timestamp(concat(curdate(),' ',curtime())) - unix_timestamp(master.fecha_hora)"
  set co [sql query $connuno "select master.*,$da from master where (master.nick = $ni and master.stat in (2,3,4)) \
                      or (master.mod = $ni and master.stat = 6) or (master.stat = 7 and master.nick = $ni)\
                      order by master.fecha_hora desc limit 1"]
  while {[set row [sql fetchrow $connuno $co]] != ""} {set tt $row }
  sql endquery $connuno $co
 }
 if {$tt == 0} {
  putserv "$targ sqllangref(notfound)."
 } else {
  switch [lindex $tt 0] {
   2
     {
       if {[string length [set msg [join [obn msg [lindex $tt 8]]]]] > 0} {set msg ", $sqllangref(diciendo): $msg"} else {set msg "."}
       set targ "$targ \002$arg ([obn ident [lindex $tt 4]]@[obn host [lindex $tt 3]])\002 $sqllangref(part) [obn chan [lindex $tt 6]]\
        $sqllangref(hace)[fec [lindex $tt 11]]$sqllangref(ago)$msg"
     }
   3
     {
       set targ "$targ \002$arg ([obn ident [lindex $tt 4]]@[obn host [lindex $tt 3]])\002 $sqllangref(sign) \
        [obn chan [lindex $tt 6]] $sqllangref(hace)[fec [lindex $tt 11]]$sqllangref(ago) $sqllangref(diciendo): [join [obn msg [lindex $tt 8]]]"
     }
   4
     {
       set targ "$targ \002$arg ([obn ident [lindex $tt 4]]@[obn host [lindex $tt 3]])\002 $sqllangref(part) [obn chan [lindex $tt 6]]\
        $sqllangref(split) $sqllangref(hace)[fec [lindex $tt 11]]$sqllangref(ago)"
     }
   6
     {
       set co [sql query $connuno "select master.ident,master.host from master,last where master.id = last.lin and last.lout = [lindex $tt 10]"]
       set nu ""
       while {[set row [sql fetchrow $connuno $co]] != ""} {set nu $row }
       if {[string length $nu] > 0 } {
        set oo " ([obn ident [lindex $nu 0]]@[obn host [lindex $nu 1]])"
       } else { set oo ""}
       sql endquery $connuno $co
       set targ "$targ \002$arg$oo\002 $sqllangref(kick) [obn chan [lindex $tt 6]]\
        $sqllangref(hace)[fec [lindex $tt 11]]$sqllangref(ago) $sqllangref(razon): [join [obn msg [lindex $tt 8]]]"
     }
   7
     {
       set targ "$targ \002$arg\002 $sqllangref(chnick) [obn nick [lindex $tt 9]] $sqllangref(encanal) [obn chan [lindex $tt 6]]\
        $sqllangref(hace)[fec [lindex $tt 11]]$sqllangref(ago)."
     }
  }
 }
 sql disconnect $connuno
 switch $n {
  0 {
     putserv $targ
    }
  1 {
     putserv $targ
    }
  2 {
     putdcc $idx $targ
    }
 }
} 

## 1 - join
## 2 - part
## 3 - sign
## 4 - split
## 5 - rejoin
## 6 - kick
## 7 - chnick
## 8 - chmode
## 9 - topc
# 10 - chon
# 11 - chjn
# 12 - chpt


proc sjoin {nick uhost hand chan} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set hos "(stat,nick,ident,host,hand,chan,bot) values(1,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick]"
 set hos "$hos$ot)"
 og $hos
 las "1,$ot,0"
}

proc spart {nick uhost hand chan {msg ""}} {
 global botnick
 set reason [limpia $msg]
 set nick [limpia $nick]; set hand [limpia $hand]
 set hos "(stat,nick,ident,host,hand,chan,bot,msg) values(2,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob msg $reason]"
 set hos "$hos$ot)"
 og $hos
 las "2,$ot,0"
}

proc ssign {nick uhost hand chan reason} {
 global botnick
 set reason [limpia $reason]
 set nick [limpia $nick]; set hand [limpia $hand]
 set hos "(stat,nick,ident,host,hand,chan,bot,msg) values(3,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob msg $reason]"
 set hos "$hos$ot)"
 og $hos
 las "3,$ot"
}

proc ssplit {nick uhost hand chan} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set hos "(stat,nick,ident,host,hand,chan,bot) values(4,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick]"
 set hos "$hos$ot)"
 og $hos
 las "4,$ot,0"
}

proc srejoin {nick uhost hand chan} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set hos "(stat,nick,ident,host,hand,chan,bot) values(5,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick]"
 set hos "$hos$ot)"
 og $hos
 las "5,$ot,0"
}

proc skick {nick uhost hand chan target reason} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set reason [limpia $reason]; set target [limpia $target]
 set hos "(stat,nick,ident,host,hand,chan,bot,mod,msg) values(6,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob nick $target],[ob msg $reason]"
 set hos "$hos$ot)"
 og $hos
 las "6,$ot"
}

proc snick {nick uhost hand chan newnick} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set newnick [limpia $newnick]
 set hos "(stat,nick,ident,host,hand,chan,bot,mod) values(7,"
 set ot "[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob nick $newnick]"
 set hos "$hos$ot)"
 og $hos
 las "7,$ot"
}

proc stopic {nick uhost hand chan topic} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set topic [limpia $topic]
 set hos "(stat,nick,ident,host,hand,chan,bot,msg) values(9,"
 set hos "$hos[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob msg $topic])"
 og $hos
}

proc mode_proc_fix {nick uhost hand chan mc {victim ""}} {
 if {$victim != ""} { append mc " $victim" }
 smode $nick $uhost $hand $chan $mc
}

proc smode {nick uhost hand chan mc} {
 global botnick
 set nick [limpia $nick]; set hand [limpia $hand]
 set mc [limpia mc]
 set hos "(stat,nick,ident,host,hand,chan,bot,mod) values(8,"
 set hos "$hos[ob nick $nick],[ob ident [ho $uhost 0]],[ob host [ho $uhost 1]],[ob hand $hand],[ob chan $chan],[ob bot $botnick],[ob msg $mc])"
 og $hos
}


set err [catch {bind raw - "% 001 *" sql_srv_conn}]

proc sql_srv_conn {txt} {
 putlog "----------->>> $txt"
}

switch $sqllang {
 1 {
     set sqllangref(dias) das
     set sqllangref(dia) da
     set sqllangref(mins) minutos
     set sqllangref(min) minuto
     set sqllangref(secs) segundos
     set sqllangref(sec) segundo
     set sqllangref(hora) hora 
     set sqllangref(horas) horas 
     set sqllangref(mismo) "Cuando te encuentres me avisas, ok?" 
     set sqllangref(diciendo) diciendo
     set sqllangref(part) "sali del canal"
     set sqllangref(sign) "sali del servidor estando en el canal" 
     set sqllangref(split) "por culpa de los servidores"
     set sqllangref(kick) "sali expulsado del canal" 
     set sqllangref(chnick) "cambi de nick a"
     set sqllangref(encanal) "en el canal"
     set sqllangref(hace) "hace " 
     set sqllangref(ago) ""
     set sqllangref(diciendo) "y diciendo"
     set sqllangref(razon) "y la razn fue"
     set sqllangref(intro) "A ver, deja busco..."
     set sqllangref(aqui) "Esta en el canal en este momento!!"
     set sqllangref(notfound) "No encontre a nadie bajo esa llave en mi base de datos."
   }
 2 {
     set sqllangref(dias) days
     set sqllangref(dia) day
     set sqllangref(mins) minutes
     set sqllangref(min) minute
     set sqllangref(secs) secondss
     set sqllangref(sec) second
     set sqllangref(hora) hour
     set sqllangref(horas) hours 
     set sqllangref(mismo) "Once your find your self, please, tell me, ok?"
     set sqllangref(diciendo) saying
     set sqllangref(part) "part the channel"
     set sqllangref(sign) "signed off the server being on channel"
     set sqllangref(split) "due a net-split"
     set sqllangref(kick) "was kicked from the channel"
     set sqllangref(chnick) "changed nick to"
     set sqllangref(encanal) "on the channel"
     set sqllangref(hace) "" 
     set sqllangref(ago) " ago"
     set sqllangref(diciendo) "and saying"
     set sqllangref(razon) "and the reason was"
     set sqllangref(intro) "hmmm, let me see...."
     set sqllangref(aqui) "On line!!"
     set sqllangref(notfound) "Could not find anyone that matches with the key given on my database."
   }
}

putlog "MySQLseen v1.1(29/nov/2000): By Sato1@undernet"
